"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _action_types = require("./action_types");

var createJwtReducer = function createJwtReducer() {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var action = arguments.length > 1 ? arguments[1] : undefined;

    switch (action.type) {
      case _action_types.UPDATE_JWT:
        {
          return action.jwt;
        }

      case _action_types.LOGOUT:
        {
          return {};
        }

      default:
        return state;
    }
  };
};

var _default = createJwtReducer;
exports.default = _default;
//# sourceMappingURL=create_jwt_reducer.js.map